
#include "base.as"

+++
+++  Any Preorder can be considered a "Skeletal" Category where the
+++  objects of the category are elements of the preorder and where
+++  there is a single morphism from A to B iff A<=B with transitivity
+++  guaranteeing that you can compose morphisms.
+++
SkeletalCategory(P:Preorder):MathCategory Categorify P with 
    hom: (A:Categorify P,B:Categorify P) -> List (A->B)
== add
    hom(A:Categorify P,B:Categorify P):List (A->B) == 
        import from P
        if (value$A)<=(value$B) then { [ (a:A):B +-> never ] } else { [ ] }
