
#include "base.as"
#library lSkeletal   "Skeletal.ao";

print << "--" << newline;
print << "-- Skeletal Exercise --" << newline;
print << "--" << newline;

import from lSkeletal;

PI:Preorder == SingleInteger add;

--
--  Turns an integer into an object in the skeletal category
--
Obj(i:SingleInteger):Categorify PI == add {
    value: PI == i pretend PI
}    
import from SkeletalCategory PI,SingleInteger;

identity5:(Obj 5 -> Obj 5) == id(Obj 5);

f:Obj 1 -> Obj 2 == { import from List (Obj 1 -> Obj 2); hom(Obj 1,Obj 2).1 };
g:Obj 2 -> Obj 3 == { import from List (Obj 2 -> Obj 3); hom(Obj 2,Obj 3).1 };

gf:Obj 1 -> Obj 3 == compose(Obj 1,Obj 2,Obj 3)(f,g);

print << "Skeletal Category test is ok." << newline


